from Products.CMFCore.utils import getToolByName
from Products.CMFPlone.utils import _createObjectByType

def setupPortalContent(context):
        """
        Import default plone content
        """
        p = context.getSite()

        existing = p.objectIds()        
        wftool = getToolByName(p, "portal_workflow")

        # Figure out the current user preferred language
        language = None
        locale = None
        request = getattr(p, 'REQUEST', None)

        if request is not None:
            pl = IUserPreferredLanguages(request)
            if pl is not None:
                languages = pl.getPreferredLanguages()
                for httplang in languages:
                    parts = (httplang.split('-') + [None, None])[:3]
                    try:
                        locale = locales.getLocale(*parts)
                        break
                    except LoadLocaleError:
                        # Just try the next combination
                        pass
                if len(languages) > 0:
                    language = languages[0]

        # Blog topic
        if 'blog' not in existing:
            _createObjectByType('Topic', p, id='blog',
                                title= 'blog', description='')


            topic = p.blog
            if language is not None:
                topic.setLanguage(language)

            type_crit = topic.addCriterion('Type','ATPortalTypeCriterion')
            type_crit.setValue('News Item')
            sort_crit = topic.addCriterion('created','ATSortCriterion')
            state_crit = topic.addCriterion('review_state', 'ATSimpleStringCriterion')
            state_crit.setValue('published')
            topic.setSortCriterion('effective', True)
            topic.unmarkCreationFlag()

            # it didn't work but it should!
            status = wftool.getStatusOf("simple_publication_workflow", topic)
            if status['review_state'] != 'published':
                wftool.doActionFor(topic, 'publish')

